# -*- coding: utf-8 -*-
""" Viewing components for WAeUP objects.
"""
import grok
from waeup.browser import WAeUPPage, WAeUPEditFormPage
from waeup.interfaces import IUniversity
from waeup.widgets.interfaces import ITableProvider

grok.templatedir('templates')

class UniversityPage(WAeUPPage):
    """ The main university page.
    """
    grok.name('index')
    grok.context(IUniversity)

    def update(self):
        self.table = ITableProvider(self.context).getTables(self)[0]
        self.table.need()

class Manage(WAeUPEditFormPage):
    """Manage the basic properties of a `University` instance.
    """
    form_fields = grok.AutoFields(IUniversity)
    grok.context(IUniversity)
    grok.require('waeup.manageUniversity')

    @grok.action('Save')
    def save(self, **data):
        self.applyData(self.context, **data)
        return
    
    @grok.action('Save and return')
    def saveAndReturn(self, **data):
        self.applyData(self.context, **data)
        self.redirect(self.url(self.context))
        return

    @grok.action('Cancel')
    def cancel(self, **data):
        self.flash('Action cancelled.')
        self.redirect(self.url(self.context))
        return
